﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;

namespace Bowling
{
    public class Camera
    {
        public Matrix View;
        public Matrix Projection;

        Vector3 position;
        Vector3 lookAt;
        Vector3 up;

        public Camera()
        {
            this.InitView();
            this.InitProjection();
        }

        private void InitView() 
        {
            position = new Vector3(-300.0f, 100.0f, 100.0f);
            lookAt = new Vector3(0.0f, 10.0f, 0.0f);
            up = Vector3.Up;

            View = Matrix.CreateLookAt(position, lookAt, up);
        }
    
        private void InitProjection()
        {
            float nearClip = 10.0f;
            float farClip = 10000.0f;            
            float aspectRatio;

            aspectRatio = (float)Configuration.Graphics.GraphicsDevice.Viewport.Width/
                (float)Configuration.Graphics.GraphicsDevice.Viewport.Height;
            
            Projection = Matrix.CreatePerspectiveFieldOfView(MathHelper.PiOver4, aspectRatio, nearClip, farClip);
        }

        public Matrix UpDateCam()
        {
            Vector3 cambioCamara = Vector3.Zero;
            float camSpeed = 7.0f;

            if (Keyboard.GetState().IsKeyDown(Keys.S))
            {
                cambioCamara.Y -= camSpeed;
            }
            if (Keyboard.GetState().IsKeyDown(Keys.W))
            {
                cambioCamara.Y += camSpeed;
            }
            if (Keyboard.GetState().IsKeyDown(Keys.A))
            {
                cambioCamara.X -= camSpeed;
            }
            if (Keyboard.GetState().IsKeyDown(Keys.D))
            {
                cambioCamara.X += camSpeed;
            }

            position += cambioCamara;
            View = Matrix.CreateLookAt(position, lookAt, up);

            return View;

            //float distanciaCamara = 100.0f;

            //posicionCamara = (worldJugador.Translation - (worldJugador.Backward * distanciaCamara)) 
            //    + new Vector3(0.0f, 200.0f, 0.0f);

            //Vista = Matrix.CreateLookAt(posicionCamara, worldJugador.Translation, arriba);

            //return Vista;
        }

    }
}